/* nc100em, an Amstrad NC100/NC200 emulator.
 * Copyright (C) 1995-2022 Russell Marks and Ian Collier.
 * See common.c for licence details.
 *
 * ppm2h.c - convert raw PPM (maxval 255) to header file.
 *
 * Not general-purpose, just a quick hack for the SDL icon.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


int main(void)
{
static char buf[128];
int w=0,h=0;
int x,y,r,g,b;

fgets(buf,sizeof(buf),stdin);
if(strcmp(buf,"P6\n")!=0)
  fprintf(stderr,"ppm2h: must be P6 type.\n"),exit(1);
  
fgets(buf,sizeof(buf),stdin);
sscanf(buf,"%d %d",&w,&h);
if(w<=0 || h<=0)
  fprintf(stderr,"ppm2h: bad width/height.\n"),exit(1);
  
fgets(buf,sizeof(buf),stdin);
if(atoi(buf)!=255)
  fprintf(stderr,"ppm2h: maxval must be 255.\n"),exit(1);

printf("/* auto-generated, edits will be lost */\n\n");
printf("#define DNC100EM_ICON_WIDTH\t%d\n",w);
printf("#define DNC100EM_ICON_HEIGHT\t%d\n",h);
printf("\nstatic unsigned char dnc100em_icon_data[]=\n  {\n");

for(y=0;y<h;y++)
  {
  for(x=0;x<w;x++)
    {
    /* XXX some great error-checking here */
    r=getchar();
    g=getchar();
    b=getchar();
    printf("  %d,%d,%d,\n",r,g,b);
    }
  }

printf("  };\n");

exit(0);
}
